/*
 *
 * Copyright (C) 2000  Robert Olsson, Jens Ls 
 * Swedish University of Agricultural Sciences
 *
 * This file is part of GNU Zebra.
 *
 * GNU Zebra is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * GNU Zebra is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNU Zebra; see the file COPYING.  If not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.  
 */

#define ASSERT_DEFAULT_PREFERENCE         100
#define ASSERT_DEFAULT_METRIC              80

#define ASSERT_NOTFOUND_PREFERENCE 0x7fffffff
#define ASSERT_NOTFOUND_METRIC     0xffffffff

#define ASSERT_RPT_BIT             0x80000000 /* In network byte order */

u_int32_t mg_get_metric(struct mgrp *mg, struct interface *ifp);
u_int32_t mg_get_preference(struct mgrp *mg, struct interface *ifp);
u_int32_t mr_get_metric(struct mrt *mr, struct interface *ifp);
u_int32_t mr_get_preference(struct mrt *mr, struct interface *ifp);

void send_pim_assert(struct interface *ifp, 
		     u_int32_t group, u_int32_t source, u_int32_t rpt,
		     u_int32_t preference, u_int32_t metric);



void
process_assert(struct encoded_group *eg, 
               struct encoded_unicast *eu, 
               u_int32_t rpt,
               u_int32_t preference,
               u_int32_t metric,
               struct interface *ifp,
               u_int32_t src);
